zoukankan      html  css  js  c++  java
  • HDU2955 背包DP

    Robberies

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 21310    Accepted Submission(s): 7885


    Problem Description
    The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


    For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


    His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
     
    Input
    The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
    Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
     
    Output
    For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

    Notes and Constraints
    0 < T <= 100
    0.0 <= P <= 1.0
    0 < N <= 100
    0 < Mj <= 100
    0.0 <= Pj <= 1.0
    A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
     
    Sample Input
    3
    0.04 3
    1 0.02
    2 0.03
    3 0.05
    0.06 3
    2 0.03
    2 0.03
    3 0.05
    0.10 3
    1 0.03
    2 0.02
    3 0.05
     
    Sample Output
    2
    4
    6
     
    Source
     题意:
    一人去抢银行,n个银行,在每个银行能够得到的钱mj,被抓住的概率pj,抢所有银行被抓住的概率p,问在总概率不超过p时得到的最大钱数。
    代码:
     1 //由于存在概率的乘法,用普通的01背包肯定不行,可以以总钱数作为背包的容量,求不被抓到的最大概率,最后for语句,钱数递减找到第一个符合的概率即可。
     2 //注意初始化背包时f[0]=1,其他的是0;被抓的概率是1减去不被抓的概率。
     3 #include<iostream>
     4 #include<cstdio>
     5 using namespace std;
     6 int t,n;
     7 double p,pj[105];
     8 int mj[105];
     9 double f[10004];
    10 int main()
    11 {
    12     scanf("%d",&t);
    13     while(t--)
    14     {
    15         int sum=0;
    16         for(int i=1;i<=10000;i++)
    17         f[i]=0;
    18         f[0]=1;
    19         scanf("%lf%d",&p,&n);
    20         for(int i=1;i<=n;i++)
    21         {
    22             scanf("%d%lf",&mj[i],&pj[i]);
    23             sum+=mj[i];
    24             pj[i]=1-pj[i];
    25         }
    26         for(int i=1;i<=n;i++)
    27         {
    28             for(int k=sum;k>=mj[i];k--)
    29             {
    30                 f[k]=max(f[k],f[k-mj[i]]*pj[i]);
    31             }
    32         }
    33         for(int i=sum;i>=0;i--)
    34         {
    35             if(1-f[i]<=p)
    36             {
    37                 printf("%d
    ",i);
    38                 break;
    39             }
    40         }
    41     }
    42     return 0;
    43 }
  • 相关阅读:
    poj1228 Grandpa's Estate
    poj1113 Wall
    poj2826 An Easy Problem?!
    poj1269 Intersecting Lines
    poj3304 Segments
    BZOJ3832Rally题解
    BZOJ2802Warehouse Store题解
    李超树详解
    BZOJ4241历史研究题解
    洛谷2050 BZOJ2897美食节题解
  • 原文地址:https://www.cnblogs.com/--ZHIYUAN/p/5982881.html
Copyright © 2011-2022 走看看